# Peruvian Bills/Notes Detector

## Data Science technologies for Identify and detect peruvian currency (bills and notes)

### By Romell Domínguez
[![](https://raw.githubusercontent.com/romellfudi/assets/master/favicon.ico#favico)](https://www.romellfudi.com/)

## Target of Repository:
![](preview/target_image.jpg)

### You can also view online via:

#### Multiclass Logistic Regression -> [![NBViwer](https://img.shields.io/badge/display-nbviwer-blue.svg)](http://nbviewer.jupyter.org/github/romellfudi/dataset_currency/blob/master/Jose_Taquia_All_TransferLearning_LRMultiClass_saveload.ipynb) [![Binder](https://mybinder.org/badge.svg)](https://mybinder.org/v2/gh/romellfudi/dataset_currency/master?filepath=Jose_Taquia_All_TransferLearning_LRMultiClass_saveload.ipynb) [![Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/romellfudi/dataset_currency/blob/master/Jose_Taquia_All_TransferLearning_LRMultiClass_saveload.ipynb)

#### Mask RCNN -> [![NBViwer](https://img.shields.io/badge/display-nbviwer-blue.svg)](http://nbviewer.jupyter.org/github/romellfudi/dataset_currency/blob/master/Mask_RCNN_worked.ipynb) [![Binder](https://mybinder.org/badge.svg)](https://mybinder.org/v2/gh/romellfudi/dataset_currency/master?filepath=Mask_RCNN_worked.ipynb) [![Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/romellfudi/dataset_currency/blob/master/Mask_RCNN_worked.ipynb)

#### TensorFlow Object Detection -> [![NBViwer](https://img.shields.io/badge/display-nbviwer-blue.svg)](http://nbviewer.jupyter.org/github/romellfudi/dataset_currency/blob/master/Peruvian_Detect_Multiple_Bills_2_rates.ipynb) [![Binder](https://mybinder.org/badge.svg)](https://mybinder.org/v2/gh/romellfudi/dataset_currency/master?filepath=Peruvian_Detect_Multiple_Bills_2_rates.ipynb) [![Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/romellfudi/dataset_currency/blob/master/Peruvian_Detect_Multiple_Bills_2_rates.ipynb)

#### YOLO V2 Darknet -> [![NBViwer](https://img.shields.io/badge/display-nbviwer-blue.svg)](http://nbviewer.jupyter.org/github/romellfudi/dataset_currency/blob/master/yolo_v2_tiny-bills.ipynb) [![Binder](https://mybinder.org/badge.svg)](https://mybinder.org/v2/gh/romellfudi/dataset_currency/master?filepath=yolo_v2_tiny-bills.ipynb) [![Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/github/romellfudi/dataset_currency/blob/master/yolo_v2_tiny-bills.ipynb)

### Yolo Preview:
![](preview/yolo.png)

## Requirements

* [Python 3.6](https://www.python.org/downloads/release/python-360/)
* [Jupyter Notebook](http://jupyter.org/)

## License

MIT. See the LICENSE file for the copyright notice.

**2019, October**

<style>
img[src*='#favico'] { 
    width:200px;
    display: block;
    margin: auto;
}
</style>